import 'dart:io';

import '../sys/Command.dart';

class InputStream {
  final Socket _socket;

  InputStream(this._socket);

  Command readCommand(List<int> data) {
    var strData = readString(data);
    return strData != null ? Command.fromString(strData) : null;
  }

  List<int> readBytes(List<int> data) {
    return data.sublist(4);
  }

  String readString(List<int> data) {
    return String.fromCharCodes(readBytes(data));
  }

  bool readBoolean(List<int> data) {
    return data[0] == 1;
  }

  int readInt(List<int> data) {
    int ch1 = data[0];
    int ch2 = data[1];
    int ch3 = data[2];
    int ch4 = data[3];

    if (ch1 | ch2 | ch3 | ch4 < 0)
      return null;

    return ((ch1 << 24) + (ch2 << 16) + (ch3 << 8) + (ch4 << 0));
  }
}